image: python:latest

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# https://pip.pypa.io/en/stable/topics/caching/
cache:
  paths:
    - .cache/pip

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - docker-build
  - docker-deploy

build-job:
    stage: build
    script:
        #crea entorno virtual de python
        - python -m venv .env
        #activa el entorno virtual
        - source .env/bin/activate
        #instala en el entorno las librerías detalladas en el txt
        - pip install -r requirements.txt
    cache:
        paths:
            - .env/ #guarda en cache el entorno creado

test-job:
    stage: test
    script:
    #activa el entorno creado anteriormente
    - source .env/bin/activate
    #ejecuta las pruebas unitarias y genera un reporte
    - pytest --junitxml=pytest_report.xml
    #guarda el reporte como artefacto
    artifacts:
        reports:        
            junit: pytest_report.xml
    needs:
        - build-job

docker-build-job:
    stage: docker-build
    image: docker:cli
    services:
        - docker:dind
    script:
        - docker build -t $DOCKER_USR/$DOCKER_IMAGE_NAME:$CI_PIPELINE_IID .
        - docker save --output $DOCKER_IMAGE_NAME.tar $DOCKER_USR/$DOCKER_IMAGE_NAME:$CI_PIPELINE_IID
    rules:
        - if: $CI_COMMIT_BRANCH
        - exists:
            - Dockerfile
    artifacts:
        expire_in: 5 minutes
        paths:
            - $DOCKER_IMAGE_NAME.tar
    needs:
        - test-job

docker-deploy-job:
    stage: docker-deploy
    image: docker:cli
    services:
        - docker:dind
    before_script:
        - docker login -u $DOCKER_USR -p $DOCKER_PASS
    script:
        - docker load -q -i $DOCKER_IMAGE_NAME.tar
        - docker push $DOCKER_USR/$DOCKER_IMAGE_NAME:$CI_PIPELINE_IID
    needs:
        - docker-build-job